(defvar f1        "eval"           )
(defvar f2        "toString"       )
(defvar c1        "Const"          )
(defvar c2        "Add"            )
(defvar f1mod     "EvalMod"        )
(defvar f2mod     "ToStringMod"    )
(defvar f1c1      (concat f1 c1)   )
(defvar f1c2      (concat f1 c2)   )
(defvar f2c1      (concat f2 c1)   )
(defvar f2c2      (concat f2 c2)   )
(defvar c1mod     (concat c1 "Mod"))
(defvar c2mod     (concat c2 "Mod"))
(defvar f1reducer "fold"          )
(defvar f2reducer "fold2"          )
(defvar dummyc1   "c"              )
(defvar dummyc2   "a"              )
(defvar clientmod "Client"         )


; 1) Introduce definitions for equations ------------------------------------------------------
(haskell-refac-newDefEqBodyIn f1 c1 f1c1 f1mod)
(haskell-refac-newDefEqBodyIn f1 c2 f1c2 f1mod)
(haskell-refac-newDefEqBodyIn f2 c1 f2c1 f2mod)
(haskell-refac-newDefEqBodyIn f2 c2 f2c2 f2mod) 

; 2) abstract pattern variables or rec calls on pattern variables -----------------------------
(haskell-refac-generalisePatternVariableInLocalDefIn f1 c1 f1c1 f1mod "0" "Curried")
(haskell-refac-generalisePatternVariableInLocalDefIn f2 c1 f2c1 f2mod "0" "Curried")
(haskell-refac-generaliseRecAppToPatternVariableInLocalDefIn f2 c2 f2c2 f2mod "1" "y" "UnCurried")
(haskell-refac-generaliseRecAppToPatternVariableInLocalDefIn f2 c2 f2c2 f2mod "0" "x" "UnCurried")
(haskell-refac-generaliseRecAppToPatternVariableInLocalDefIn f1 c2 f1c2 f1mod "1" "y" "UnCurried")
(haskell-refac-generaliseRecAppToPatternVariableInLocalDefIn f1 c2 f1c2 f1mod "0" "x" "UnCurried") 

; 3) lift the business functions to the top level ---------------------------------------------
(haskell-refac-liftDefToTopLevelIn f1 f1c1 f1mod)
(haskell-refac-liftDefToTopLevelIn f1 f1c2 f1mod)
(haskell-refac-liftDefToTopLevelIn f2 f2c1 f2mod)
(haskell-refac-liftDefToTopLevelIn f2 f2c2 f2mod) 


; 4) abstract the business functions in the functions of interest -----------------------------
(haskell-refac-generaliseIdentIn f1 f1mod f1c1 dummyc1)
(haskell-refac-generaliseIdentIn f1 f1mod f1c2 dummyc2)
(haskell-refac-generaliseIdentIn f2 f2mod f2c1 dummyc1)
(haskell-refac-generaliseIdentIn f2 f2mod f2c2 dummyc2) 

; 5) rename the functions of interest (they have become traversal iterators) ------------------
(haskell-refac-renameTopLevelIdent f1 f1mod f1reducer)
(haskell-refac-renameTopLevelIdent f2 f2mod f2reducer) 


; 6) reconstruct the functions of interest as calls to the traversal functions ----------------
(haskell-refac-newDefIdentApp f1reducer f1 clientmod)
(haskell-refac-newDefIdentApp f2reducer f2 clientmod) 
(haskell-refac-liftDefToTopLevel f1 clientmod)
(haskell-refac-liftDefToTopLevel f2 clientmod) 
(haskell-refac-generaliseIdentIn f1 clientmod "e1" "x") 
(haskell-refac-generaliseIdentIn f2 clientmod "e1" "x") 

; 7) make calls to function of interest appear and move them ----------------------------------
(haskell-refac-foldToplevelDefinition f1 clientmod)
(haskell-refac-foldToplevelDefinition f2 clientmod)

(haskell-refac-moveDefBetweenModules f1 clientmod f1mod )
(haskell-refac-moveDefBetweenModules f2 clientmod f2mod ) 

; 4 bis) remove useless references to identifiers introduced by HaRe
(haskell-refac-unfoldIn (concat f1 "_gen") f1 f1mod)
(haskell-refac-unfoldIn (concat f1 "_gen_1") f1 f1mod)
(haskell-refac-unfoldIn (concat f2  "_gen") f2 f2mod)
(haskell-refac-unfoldIn (concat f2  "_gen_1") f2 f2mod) 
(haskell-refac-removeTopLevelDef (concat f1 "_gen") f1mod)
(haskell-refac-removeTopLevelDef (concat f1 "_gen_1") f1mod)
(haskell-refac-removeTopLevelDef (concat f2 "_gen") f2mod)
(haskell-refac-removeTopLevelDef (concat f2 "_gen_1") f2mod) 


; 8) move business functions to the data-centered modules and rename them ---------------------
(haskell-refac-moveDefBetweenModules f1c1 f1mod c1mod)
(haskell-refac-moveDefBetweenModules f1c2 f1mod c2mod)
(haskell-refac-moveDefBetweenModules f2c1 f2mod c1mod)
(haskell-refac-moveDefBetweenModules f2c2 f2mod c2mod) 

(haskell-refac-renameTopLevelIdent f1c1 c1mod f1)
(haskell-refac-renameTopLevelIdent f1c2 c2mod f1)
(haskell-refac-renameTopLevelIdent f2c1 c1mod f2)
(haskell-refac-renameTopLevelIdent f2c2 c2mod f2) 

; 7 bis) move the iterators in Expr and remove one of them (they are equivalent)
(haskell-refac-moveDefBetweenModules f1reducer f1mod "Expr")
(haskell-refac-moveDefBetweenModules f2reducer f2mod "Expr")
(haskell-refac-replaceIdentIn f2reducer f2 f2mod f1reducer)
(haskell-refac-removeTopLevelDef f2reducer "Expr")
